// run configure with --enable-local
// run make elemlist


#include <click/config.h>
#include "EtherPrint.hh"
#include <click/glue.hh>
#include <click/confparse.hh>
#include <click/error.hh>
#include <click/straccum.hh>

#include <click/packet_anno.hh>
#include <click/router.hh>
#include <click/nameinfo.hh>
#include <click/etheraddress.hh>
#include <clicknet/ether.h>

#include <clicknet/ip.h>
#include <clicknet/icmp.h>
#include <clicknet/tcp.h>
#include <clicknet/udp.h>

#if CLICK_USERLEVEL
# include <stdio.h>
#endif


CLICK_DECLS

EtherPrint::EtherPrint()
{
}

EtherPrint::~EtherPrint()
{
}

int
EtherPrint::configure(Vector<String> &conf, ErrorHandler *errh)
{
  _active = true;
  if (cp_va_kparse(conf, this, errh,
                   "LABEL", cpkP, cpString, &_label,
		   "ACTIVE", 0, cpBool, &_active,
		   cpEnd) < 0)
    return -1;
  
  return 0;
}

Packet *EtherPrint::simple_action(Packet *p)
{
  if (!_active)
    return p;

  StringAccum sa;

  if (_label)
    sa << _label << ": ";

  if(p->length()<=14)
    sa << "Ethernet Header too short";
  else
    {
      sa << EtherAddress(p->data()+6) << " -> " << EtherAddress(p->data()) << " (" << ((unsigned int)(p->data()[12]))*256+((unsigned int)(p->data()[13])) << ")";
    }

  click_chatter("%s", sa.c_str());

  return p;
}

CLICK_ENDDECLS
EXPORT_ELEMENT(EtherPrint)
