#ifndef CLICK_ETHERPRINT_HH
#define CLICK_ETHERPRINT_HH
#include <click/element.hh>
#include <click/ipaddress.hh>
CLICK_DECLS
/*
=c
EtherPrint

=s ethernet
pretty-prints Ethernet Headers

=d
Expects EthernetHeader as input. Prints out Header in a human-readable format.

=processing
agnostic

=a EtherEncap, EnsureEther, IPPrint */

class EtherPrint : public Element {
public:
  EtherPrint();
  ~EtherPrint();
  const char *class_name() const { return "EtherPrint"; }
  const char *port_count() const { return PORTS_1_1; }
  const char *processing() const { return AGNOSTIC; }
  int configure(Vector<String> &,ErrorHandler*);
  Packet *simple_action(Packet *);
  ErrorHandler *_errh;
private:
  String _label;
  bool _active;
};

CLICK_ENDDECLS
#endif
