// run configure with --enable-local
// run make elemlist


#include <click/config.h>
#include "ForwHeaderPrint.hh"
#include <click/glue.hh>
#include <click/confparse.hh>
#include <click/error.hh>
#include <click/straccum.hh>

#include <click/packet_anno.hh>
#include <click/router.hh>
#include <click/nameinfo.hh>

#include <clicknet/ip.h>
#include <clicknet/icmp.h>
#include <clicknet/tcp.h>
#include <clicknet/udp.h>

#if CLICK_USERLEVEL
# include <stdio.h>
#endif


CLICK_DECLS

ForwHeaderPrint::ForwHeaderPrint()
{
}

ForwHeaderPrint::~ForwHeaderPrint()
{
}

int
ForwHeaderPrint::configure(Vector<String> &conf, ErrorHandler *errh)
{
  _active = true;
  _label = "";
  if (cp_va_kparse(conf, this, errh,
                   "LABEL", cpkP, cpString, &_label,
		   "ACTIVE", 0, cpBool, &_active,
		   cpEnd) < 0)
    return -1;
  
  return 0;
}

Packet *ForwHeaderPrint::simple_action(Packet *p)
{
  if (!_active)
    return p;

  StringAccum sa;

  if (_label)
    sa << _label << ": ";

  if(p->length()==0)
    sa << "Invalid ForwHeader (length=0)";
  else
    if(p->length() < 4+4*(unsigned int)(p->data()[0]))
      sa << "Invalid ForwHeader (too short)";
    else
      {
	sa << "Forw options=" << (unsigned int)(p->data()[3]);
	sa << ", method=" << (unsigned int)(p->data()[2]) << ", hops=";
	for(unsigned int i=0;i<(unsigned int)(p->data()[0]);i++)
	  {
	    if(i == (unsigned int)(p->data()[1]))
	      sa << ">";
	    sa << IPAddress(p->data()+4+4*i) << "  ";
	  }
      }

  click_chatter("%s", sa.c_str());

  return p;
}

CLICK_ENDDECLS
EXPORT_ELEMENT(ForwHeaderPrint)
