#ifndef CLICK_FORWHEADERPRINT_HH
#define CLICK_FORWHEADERPRINT_HH
#include <click/element.hh>
#include <click/ipaddress.hh>
CLICK_DECLS

/*
=c
ForwHeaderPrint(ForwHeaderPrint([LABEL])

=s Forwarding Network
pretty-prints forwarding headers

=processing
agnostic

=d
Expects forwarding headers as input. Prints out Forwarding Header in a
human-readable format, preceded by the LABEL text.

=a NextHop, RevRoute, ForwHeader*/

class ForwHeaderPrint : public Element {
public:
  ForwHeaderPrint();
  ~ForwHeaderPrint();
  const char *class_name() const { return "ForwHeaderPrint"; }
  // int configure(Vector<String> &, ErrorHandler *);
  const char *port_count() const { return PORTS_1_1; }
  const char *processing() const { return AGNOSTIC; }
  int configure(Vector<String> &,ErrorHandler*);
  Packet *simple_action(Packet *);
  ErrorHandler *_errh;
private:
  String _label;
  bool _active;
};

CLICK_ENDDECLS
#endif
