// run configure with --enable-local
// run make elemlist


#include <click/config.h>
#include "NextHop.hh"

CLICK_DECLS

NextHop::NextHop() 
{
}

NextHop::~NextHop()
{
}

void NextHop::push(int port, Packet *p)
{
  unsigned int l=p->length();
  if(l<4)      // discard packet (not a valid forwarding header)
    {
      p->kill();
      return;
    }

  unsigned char n=p->data()[0];
  unsigned char i=p->data()[1];

  if(l<4*((unsigned int)n+1)) // discard packet (not a valid
			      // forwarding header)
    {
      p->kill();
      return;
    }
  
  if(i<n-1) // packet not yet at destination
    {
      if(WritablePacket *q = p->uniqueify())
	{
	  // increase i
	  q->data()[1]=i+1;
	  // annotate IP
	  q->set_dst_ip_anno(IPAddress(q->data() + 4*(i+2)));
	  output(0).push(q);
	}
    }
  else
    output(1).push(p); // packet at destination
}

CLICK_ENDDECLS
EXPORT_ELEMENT(NextHop)
