// run configure with --enable-local
// run make elemlist


#include <click/config.h>
#include "StripForwHeader.hh"

CLICK_DECLS

StripForwHeader::StripForwHeader() 
{
}

StripForwHeader::~StripForwHeader()
{
}

void StripForwHeader::push(int port, Packet *p)
{
  unsigned int l=p->length();
  if(l<4)      // discard packet (not a valid forwarding header)
    {
      p->kill();
      return;
    }

  unsigned char n=p->data()[0];

  if(l<4*((unsigned int)n+1)) // discard packet (not a valid
			      // forwarding header)
    {
      p->kill();
      return;
    }

  p->pull(4*((unsigned int)n+1));
  p->set_network_header(p->data(),(reinterpret_cast<const click_ip*>(p->data()))->ip_hl << 2);
  output(0).push(p);
}

CLICK_ENDDECLS
EXPORT_ELEMENT(StripForwHeader)
